Matrices I
1 Introduccin
2 Crear matrices y deshacer matrices
2.1 La funcin matrix()
2.2 Aadir el atributo dimensin a un vector
2.3 Unir dos o ms vectores
2.4 Forma de deshacer una matriz
3 Forma de seleccionar elementos de una matriz
3.1 Seleccin especificando los indices
3.2 Seleccin estableciendo filtros sobre matrices
4 Aadir, borrar filas y columnas de una matriz
4.1 Funciones rbind() y cbind()
5 Funciones sobre matrices
5.1 Funcin apply()
5.2 Funcin sweep()
6 Atributos de una matriz y de un array
1 Introduccin
El concepto de matriz en R es diferente al utilizado en matemticas. En R una matriz es un vector con un atributo adicional, la dimensin (dim()):
  
  La dimensin de una matriz tiene dos componentes:
  
  El nmero de filas (nrow())
El nmero de columnas (ncol())
En R los ndices empiezan en 1 a diferencia por ejemplo de Python que comienzan en 0.

Es decir una matriz es un vector con dimensin (dim()). Sin embargo, un vector en R no es una matriz.

Resumiendo

En R hay que distinguir entre matrices y vectores, en R los vectores no son ni vectores fila ni vectores columna. En matemticas un vector es considerado como una vector columna o equivalentemente una matriz de n filas y 1 columna, x???Mn1.

Las matrices en R tienen la dimensin como atributo.
Los vectores en R no tienen "dimensin".
v <- c(1,2,3,4)
dim(v)
## NULL
M <- matrix(c(1,2,3,4), nrow=2, ncol=2)
dim(M)
## [1] 2 2
En general los vectores en R se comportan como vectores filas, aunque en ciertas ocasiones lo hacen como vectores columnas.
Los escalares en R son vectores de un nico elemento.
Como vectores especiales que son las matrices, todos los elementos de la matriz deben ser del mismo tipo (mode()) y este puede ser, al igual que en los vectores "normales":
  
  numrico
complejo
cadena
lgicos
Ejemplos

Matriz de nmeros reales

M <- matrix(1:20, nrow=4)
M
##      [,1] [,2] [,3] [,4] [,5]
## [1,]    1    5    9   13   17
## [2,]    2    6   10   14   18
## [3,]    3    7   11   15   19
## [4,]    4    8   12   16   20
Matriz de nmeros complejos

M <- c(1+2i, 3+4i, 0+1i, 6+0i)
dim(M) <- c(2,2)
M
##      [,1] [,2]
## [1,] 1+2i 0+1i
## [2,] 3+4i 6+0i
Matriz de cadenas

M <- matrix( month.name, nrow=3)
M
##      [,1]       [,2]    [,3]        [,4]      
## [1,] "January"  "April" "July"      "October" 
## [2,] "February" "May"   "August"    "November"
## [3,] "March"    "June"  "September" "December"
Matriz de boolenaos

M <- matrix(rep(c(TRUE,FALSE), 4), nrow=4)
M  
##       [,1]  [,2]
## [1,]  TRUE  TRUE
## [2,] FALSE FALSE
## [3,]  TRUE  TRUE
## [4,] FALSE FALSE
2 Crear matrices y deshacer matrices
En R:
  
  Los ndices en las matrices comienzan en 1. El primer elemento de la matriz M es M[1,1].
Los ndices de una matriz entre corchetes (no entre parntesis)
Hay tres formas bsicas de crear matrices:
  
  La funcin matrix().
Aadiendo el atributo dimensin a un vector.
Uniendo dos o ms vectores.
2.1 La funcin matrix()
Sintaxis

matrix(data = NA, nrow = 1, ncol = 1, byrow = FALSE,
       dimnames = NULL)
donde:
  
  
  data	vector de datos de longitud n
nrwo	nmero de filas de la matriz
ncol	nmero de columnas de la matriz
byrow	forma de llenar el espacio de la matriz. Por defecto, por columnas.
dimnames	nombres de las filas y de las columnas de la matriz (atributo).
En R las matrices se rellenan y guardan columna a columna.

y <- matrix(c(1,2,3,4), nrow=2, ncol=2)
y
##      [,1] [,2]
## [1,]    1    3
## [2,]    2    4
M <- matrix(c(1,2,3,4),2,2)
M
##      [,1] [,2]
## [1,]    1    3
## [2,]    2    4
Si se quiere rellenar la matriz por filas hay que utilizar la opcin byrow=TRUE.
y <- matrix(c(1,2,3,4), nrow=2, ncol=2, byrow=TRUE)
y
##      [,1] [,2]
## [1,]    1    2
## [2,]    3    4
A = matrix( 
  c(2, 4, 3, 1, 5, 7), # Los datos de la matriz
  nrow=2,              # nmero de filas
  ncol=3,              # nmero de columnas 
  byrow = TRUE)        # rellenar por filas
A
##      [,1] [,2] [,3]
## [1,]    2    4    3
## [2,]    1    5    7
dimnames(A) = list( 
  c("Fila1", "Fila"),         # nombre filas 
  c("Col1", "Col2", "col3"))  # nombre columnas
A
##       Col1 Col2 col3
## Fila1    2    4    3
## Fila     1    5    7
Los nombres de las filas y columnas de una matriz se pueden especificar de dos formas distintas, con la opcin dinames dentro de la funcin matrix(), o bien utilizando las funciones rwonames() y colnames() fuera de la funcin matrix().
M <- matrix(c(1,2,3,4),2,2)
M
##      [,1] [,2]
## [1,]    1    3
## [2,]    2    4
rownames(M) <- c('Fila1', 'Fila2')
M
##       [,1] [,2]
## Fila1    1    3
## Fila2    2    4
colnames(M) <- c('Columna1', 'Columna2')
M
##       Columna1 Columna2
## Fila1        1        3
## Fila2        2        4
# Borra nombres
rownames(M) <-c()
colnames(M) <-c()
M
##      [,1] [,2]
## [1,]    1    3
## [2,]    2    4
2.2 Aadir el atributo dimensin a un vector
vector <- 1:20
class(vector)
## [1] "integer"
dim(vector)
## NULL
dim(vector) <- c(5,4)
vector
##      [,1] [,2] [,3] [,4]
## [1,]    1    6   11   16
## [2,]    2    7   12   17
## [3,]    3    8   13   18
## [4,]    4    9   14   19
## [5,]    5   10   15   20
class(vector)
## [1] "matrix"
2.3 Unir dos o ms vectores
Uniendo dos o ms vectores con las funciones

cbind() Los une como vectores columna
rbind() Los une como vectores fila
vector1 <- 1:20
vector2 <- 21:30
vector3 <- 31:40

cbind(vector1, vector2, vector3)
##       vector1 vector2 vector3
##  [1,]       1      21      31
##  [2,]       2      22      32
##  [3,]       3      23      33
##  [4,]       4      24      34
##  [5,]       5      25      35
##  [6,]       6      26      36
##  [7,]       7      27      37
##  [8,]       8      28      38
##  [9,]       9      29      39
## [10,]      10      30      40
## [11,]      11      21      31
## [12,]      12      22      32
## [13,]      13      23      33
## [14,]      14      24      34
## [15,]      15      25      35
## [16,]      16      26      36
## [17,]      17      27      37
## [18,]      18      28      38
## [19,]      19      29      39
## [20,]      20      30      40
2.4 Forma de deshacer una matriz
Una matriz se convierte en vector, es decir pierde el atributo dimensin, aplicando la funcin c() a la matriz.

Ejemplo

Pasar de la mattriz M a al vector M1

M
##      [,1] [,2]
## [1,]    1    3
## [2,]    2    4
dim(M)
## [1] 2 2
is.matrix(M)
## [1] TRUE
M1 <- c(M)
dim(M1)
## NULL
is.matrix(M1)
## [1] FALSE
3 Forma de seleccionar elementos de una matriz
3.1 Seleccin especificando los indices
Como en el caso de los vectores hay diferentes formas de seleccionar elementos de una matriz.

Para seleccionar un nico elemento se emplea la sintaxis M[i,j] que toma el elemento de la i-sima fila y j-sima columna

Para seleccionar una fila la sintaxis es M[i,] que selecciona toda la i-sima fila.

Para seleccionar una columna la sintaxis es M[,j] que selecciona toda la i-sima columna.

Para seleccionar varias columnas y filas:
  
  M[3:7,] selecciona las filas consecutivas 3, 4, 5, 6, 7
M[,seq(8,12) ] selecciona las columnas consecutivas 8, 9, 10, 11, 12
M[c(3,9,13), ] selecciona las filas 3, 9, 13
Notas

Cuando el ndice es negativo, el efecto que se consigue es excluir los elementos referenciados. Por ejemplo, y[-2, ] elimina la segunda fila del la matriz y.
y <- matrix(1:10, nrow=5)
y
##      [,1] [,2]
## [1,]    1    6
## [2,]    2    7
## [3,]    3    8
## [4,]    4    9
## [5,]    5   10
# Eliminamos la segunda fila de la matriz y
y[-2,]
##      [,1] [,2]
## [1,]    1    6
## [2,]    3    8
## [3,]    4    9
## [4,]    5   10
Por defecto, los elementos seleccionados de una matriz se convierten en vectores. Para que los elementos seleccionados conserven el atributo de la dimensin es necesario especificar la opcin drop=TRUE.
Mirar los siguientes ejemplos,(para ms informacin help("["))

Mat <- matrix(1:20, nrow=5)
Mat[,c(2,4)]
Mat[,2]
Mat[,2, drop=FALSE]
Mat[3,, drop=FALSE]
3.2 Seleccin estableciendo filtros sobre matrices
Se pueden establecer filtros sobre matrices utilizando operadores aritmticos, relacionales, etc

x[x[,2]>=3]
j <- x[,2] >=3
4 Aadir, borrar filas y columnas de una matriz
Las matrices como los vectores no pueden cambiar de tamao.
Lo que se hacer al aadir o eliminar filas o columnas es reasignar el objeto a otro "espacio" de memoria.
Problema: Esta reasignacin consume muchos recursos y es lenta.
4.1 Funciones rbind() y cbind()
Las funciones rbind() y cbind() las hemos utilizado para crea matrices a partir de un conjunto de vectores. Otra de las acciones que realizan estas dos funciones es combinar dos o ms matrices para obtener otra matriz.

La funcin cbind() crea una nueva matriz combinando dos matrices, aade las columnas de la segunda a la primera.

La funcin rbind() crea una nueva matriz combinando dos matrices, aade las filas de la segunda a la primera.

Ejemplo

mat1 <- matrix(1:16, ncol = 4)
mat1
##      [,1] [,2] [,3] [,4]
## [1,]    1    5    9   13
## [2,]    2    6   10   14
## [3,]    3    7   11   15
## [4,]    4    8   12   16
mat2 <- matrix(30:53, ncol = 4)
mat2
##      [,1] [,2] [,3] [,4]
## [1,]   30   36   42   48
## [2,]   31   37   43   49
## [3,]   32   38   44   50
## [4,]   33   39   45   51
## [5,]   34   40   46   52
## [6,]   35   41   47   53
mat3 <- matrix(100:119, nrow = 4)
mat3
##      [,1] [,2] [,3] [,4] [,5]
## [1,]  100  104  108  112  116
## [2,]  101  105  109  113  117
## [3,]  102  106  110  114  118
## [4,]  103  107  111  115  119
# Funcin rbind una matriz encima de la otra
rbind(mat1, mat2)
##       [,1] [,2] [,3] [,4]
##  [1,]    1    5    9   13
##  [2,]    2    6   10   14
##  [3,]    3    7   11   15
##  [4,]    4    8   12   16
##  [5,]   30   36   42   48
##  [6,]   31   37   43   49
##  [7,]   32   38   44   50
##  [8,]   33   39   45   51
##  [9,]   34   40   46   52
## [10,]   35   41   47   53
# Funcin rbind una matriz al lado  de la otra
cbind(mat1, mat3)
##      [,1] [,2] [,3] [,4] [,5] [,6] [,7] [,8] [,9]
## [1,]    1    5    9   13  100  104  108  112  116
## [2,]    2    6   10   14  101  105  109  113  117
## [3,]    3    7   11   15  102  106  110  114  118
## [4,]    4    8   12   16  103  107  111  115  119
5 Funciones sobre matrices
La familia de funciones *apply trabajan sobre los diferentes objetos de R pudiendo sustituir a los bucles (son bucles implcitos)

5.1 Funcin apply()
Sintaxis

apply(matriz, cdigo de dimensin, funcin, argumentos de la funcin)
cdigo de dimensin???{12se aplica la funcin por filasse aplica la funcin por columnas
  
  Ejemplo 1: funcin mean()
  
  Dada la matriz m se quiere calcular la media de cada una de sus columnas.
  
  Para resolver este problema vamos a aplicar la funcin mean() a cada una de las columnas por medio de la funcin apply()
  
  m <- matrix(1:20, nrow=4, ncol=5)
  m
  ##      [,1] [,2] [,3] [,4] [,5]
  ## [1,]    1    5    9   13   17
  ## [2,]    2    6   10   14   18
  ## [3,]    3    7   11   15   19
  ## [4,]    4    8   12   16   20
  # Se aplica la funcin mean() por columnas
  apply(m,2,mean)
  ## [1]  2.5  6.5 10.5 14.5 18.5
  Este resultado se obtiene igual con la funcin colMeans()
  
  m <- matrix(1:20, nrow=4, ncol=5)
  m
  ##      [,1] [,2] [,3] [,4] [,5]
  ## [1,]    1    5    9   13   17
  ## [2,]    2    6   10   14   18
  ## [3,]    3    7   11   15   19
  ## [4,]    4    8   12   16   20
  apply(m,1,mean)
  ## [1]  9 10 11 12
  Este resultado se obtiene igual con la funcin rowMeans()
  
  rowMeans(m)
  ## [1]  9 10 11 12
  En general las funciones colMeans() y rowMeans() son ms rpidas.
  
  Ejemplo 2
  
  Definimos la funcin f(x)=x2,8 y queremos aplicarlo a las filas de una matriz.
  
  # Definimos la funcin
  fun <- function(x) x/c(2,8)
  # Matriz m2
  m2 <- matrix(seq(1,6), nrow=3)
  m2
  ##      [,1] [,2]
  ## [1,]    1    4
  ## [2,]    2    5
  ## [3,]    3    6
  # Aplicamos la funcin a las filas de la matriz m2
  y <- apply(m2,1,fun)
  y
  ##      [,1]  [,2] [,3]
  ## [1,]  0.5 1.000 1.50
  ## [2,]  0.5 0.625 0.75
  Qu ha hecho R? Recycling
  
  La matriz m es,
  m2=?????????123456????????????m2=(124822583268)
  
  5.2 Funcin sweep()
  Como la funcin apply, los dos primeros son la matriz y la dimensin sobre la que aplicaremos la funcin. El tercero es el vector de valores para procesar cada fila o columna de forma distinta y finalmente, el cuarto argumento es la funcin a aplicar.
  
  Como funciones a aplicar podemos utilizar, + Operadores binarios: la suma "+", la resta "-" (valor por defecto), el producto "*" y el cociente "/", siempre con comillas. + Otra funcin
  
  Sintaxis
  
  sweep(x, MARGIN, STATS, FUN = "-", check.margin = TRUE, ...)
  
  Ejemplo 1 Queremos restar a cada columna su elemento mximo.
  
  # Conjunto de datos "iris"
  
  iris2 <- as.matrix(iris[,1:4])      # Del data frame iris extraemos las 4 primeras columnas y las convertimos en matriz
  maximos <- apply(iris2, 2, max)     # Por medio de apply obtenmos los mximos de cada columna
  sweep(iris2, 2, maximos,'-')
  ##        Sepal.Length Sepal.Width Petal.Length Petal.Width
  ##   [1,]         -2.8        -0.9         -5.5        -2.3
  ##   [2,]         -3.0        -1.4         -5.5        -2.3
  ##   [3,]         -3.2        -1.2         -5.6        -2.3
  ##   [4,]         -3.3        -1.3         -5.4        -2.3
  ##   [5,]         -2.9        -0.8         -5.5        -2.3
  ##   [6,]         -2.5        -0.5         -5.2        -2.1
  ##   [7,]         -3.3        -1.0         -5.5        -2.2
  ##   [8,]         -2.9        -1.0         -5.4        -2.3
  ##   [9,]         -3.5        -1.5         -5.5        -2.3
  ##  [10,]         -3.0        -1.3         -5.4        -2.4
  ##  [11,]         -2.5        -0.7         -5.4        -2.3
  ##  [12,]         -3.1        -1.0         -5.3        -2.3
  ##  [13,]         -3.1        -1.4         -5.5        -2.4
  ##  [14,]         -3.6        -1.4         -5.8        -2.4
  ##  [15,]         -2.1        -0.4         -5.7        -2.3
  ##  [16,]         -2.2         0.0         -5.4        -2.1
  ##  [17,]         -2.5        -0.5         -5.6        -2.1
  ##  [18,]         -2.8        -0.9         -5.5        -2.2
  ##  [19,]         -2.2        -0.6         -5.2        -2.2
  ##  [20,]         -2.8        -0.6         -5.4        -2.2
  ##  [21,]         -2.5        -1.0         -5.2        -2.3
  ##  [22,]         -2.8        -0.7         -5.4        -2.1
  ##  [23,]         -3.3        -0.8         -5.9        -2.3
  ##  [24,]         -2.8        -1.1         -5.2        -2.0
  ##  [25,]         -3.1        -1.0         -5.0        -2.3
  ##  [26,]         -2.9        -1.4         -5.3        -2.3
  ##  [27,]         -2.9        -1.0         -5.3        -2.1
  ##  [28,]         -2.7        -0.9         -5.4        -2.3
  ##  [29,]         -2.7        -1.0         -5.5        -2.3
  ##  [30,]         -3.2        -1.2         -5.3        -2.3
  ##  [31,]         -3.1        -1.3         -5.3        -2.3
  ##  [32,]         -2.5        -1.0         -5.4        -2.1
  ##  [33,]         -2.7        -0.3         -5.4        -2.4
  ##  [34,]         -2.4        -0.2         -5.5        -2.3
  ##  [35,]         -3.0        -1.3         -5.4        -2.3
  ##  [36,]         -2.9        -1.2         -5.7        -2.3
  ##  [37,]         -2.4        -0.9         -5.6        -2.3
  ##  [38,]         -3.0        -0.8         -5.5        -2.4
  ##  [39,]         -3.5        -1.4         -5.6        -2.3
  ##  [40,]         -2.8        -1.0         -5.4        -2.3
  ##  [41,]         -2.9        -0.9         -5.6        -2.2
  ##  [42,]         -3.4        -2.1         -5.6        -2.2
  ##  [43,]         -3.5        -1.2         -5.6        -2.3
  ##  [44,]         -2.9        -0.9         -5.3        -1.9
  ##  [45,]         -2.8        -0.6         -5.0        -2.1
  ##  [46,]         -3.1        -1.4         -5.5        -2.2
  ##  [47,]         -2.8        -0.6         -5.3        -2.3
  ##  [48,]         -3.3        -1.2         -5.5        -2.3
  ##  [49,]         -2.6        -0.7         -5.4        -2.3
  ##  [50,]         -2.9        -1.1         -5.5        -2.3
  ##  [51,]         -0.9        -1.2         -2.2        -1.1
  ##  [52,]         -1.5        -1.2         -2.4        -1.0
  ##  [53,]         -1.0        -1.3         -2.0        -1.0
  ##  [54,]         -2.4        -2.1         -2.9        -1.2
  ##  [55,]         -1.4        -1.6         -2.3        -1.0
  ##  [56,]         -2.2        -1.6         -2.4        -1.2
  ##  [57,]         -1.6        -1.1         -2.2        -0.9
  ##  [58,]         -3.0        -2.0         -3.6        -1.5
  ##  [59,]         -1.3        -1.5         -2.3        -1.2
  ##  [60,]         -2.7        -1.7         -3.0        -1.1
  ##  [61,]         -2.9        -2.4         -3.4        -1.5
  ##  [62,]         -2.0        -1.4         -2.7        -1.0
  ##  [63,]         -1.9        -2.2         -2.9        -1.5
  ##  [64,]         -1.8        -1.5         -2.2        -1.1
  ##  [65,]         -2.3        -1.5         -3.3        -1.2
  ##  [66,]         -1.2        -1.3         -2.5        -1.1
  ##  [67,]         -2.3        -1.4         -2.4        -1.0
  ##  [68,]         -2.1        -1.7         -2.8        -1.5
  ##  [69,]         -1.7        -2.2         -2.4        -1.0
  ##  [70,]         -2.3        -1.9         -3.0        -1.4
  ##  [71,]         -2.0        -1.2         -2.1        -0.7
  ##  [72,]         -1.8        -1.6         -2.9        -1.2
  ##  [73,]         -1.6        -1.9         -2.0        -1.0
  ##  [74,]         -1.8        -1.6         -2.2        -1.3
  ##  [75,]         -1.5        -1.5         -2.6        -1.2
  ##  [76,]         -1.3        -1.4         -2.5        -1.1
  ##  [77,]         -1.1        -1.6         -2.1        -1.1
  ##  [78,]         -1.2        -1.4         -1.9        -0.8
  ##  [79,]         -1.9        -1.5         -2.4        -1.0
  ##  [80,]         -2.2        -1.8         -3.4        -1.5
  ##  [81,]         -2.4        -2.0         -3.1        -1.4
  ##  [82,]         -2.4        -2.0         -3.2        -1.5
  ##  [83,]         -2.1        -1.7         -3.0        -1.3
  ##  [84,]         -1.9        -1.7         -1.8        -0.9
  ##  [85,]         -2.5        -1.4         -2.4        -1.0
  ##  [86,]         -1.9        -1.0         -2.4        -0.9
  ##  [87,]         -1.2        -1.3         -2.2        -1.0
  ##  [88,]         -1.6        -2.1         -2.5        -1.2
  ##  [89,]         -2.3        -1.4         -2.8        -1.2
  ##  [90,]         -2.4        -1.9         -2.9        -1.2
  ##  [91,]         -2.4        -1.8         -2.5        -1.3
  ##  [92,]         -1.8        -1.4         -2.3        -1.1
  ##  [93,]         -2.1        -1.8         -2.9        -1.3
  ##  [94,]         -2.9        -2.1         -3.6        -1.5
  ##  [95,]         -2.3        -1.7         -2.7        -1.2
  ##  [96,]         -2.2        -1.4         -2.7        -1.3
  ##  [97,]         -2.2        -1.5         -2.7        -1.2
  ##  [98,]         -1.7        -1.5         -2.6        -1.2
  ##  [99,]         -2.8        -1.9         -3.9        -1.4
  ## [100,]         -2.2        -1.6         -2.8        -1.2
  ## [101,]         -1.6        -1.1         -0.9         0.0
  ## [102,]         -2.1        -1.7         -1.8        -0.6
  ## [103,]         -0.8        -1.4         -1.0        -0.4
  ## [104,]         -1.6        -1.5         -1.3        -0.7
  ## [105,]         -1.4        -1.4         -1.1        -0.3
  ## [106,]         -0.3        -1.4         -0.3        -0.4
  ## [107,]         -3.0        -1.9         -2.4        -0.8
  ## [108,]         -0.6        -1.5         -0.6        -0.7
  ## [109,]         -1.2        -1.9         -1.1        -0.7
  ## [110,]         -0.7        -0.8         -0.8         0.0
  ## [111,]         -1.4        -1.2         -1.8        -0.5
  ## [112,]         -1.5        -1.7         -1.6        -0.6
  ## [113,]         -1.1        -1.4         -1.4        -0.4
  ## [114,]         -2.2        -1.9         -1.9        -0.5
  ## [115,]         -2.1        -1.6         -1.8        -0.1
  ## [116,]         -1.5        -1.2         -1.6        -0.2
  ## [117,]         -1.4        -1.4         -1.4        -0.7
  ## [118,]         -0.2        -0.6         -0.2        -0.3
  ## [119,]         -0.2        -1.8          0.0        -0.2
  ## [120,]         -1.9        -2.2         -1.9        -1.0
  ## [121,]         -1.0        -1.2         -1.2        -0.2
  ## [122,]         -2.3        -1.6         -2.0        -0.5
  ## [123,]         -0.2        -1.6         -0.2        -0.5
  ## [124,]         -1.6        -1.7         -2.0        -0.7
  ## [125,]         -1.2        -1.1         -1.2        -0.4
  ## [126,]         -0.7        -1.2         -0.9        -0.7
  ## [127,]         -1.7        -1.6         -2.1        -0.7
  ## [128,]         -1.8        -1.4         -2.0        -0.7
  ## [129,]         -1.5        -1.6         -1.3        -0.4
  ## [130,]         -0.7        -1.4         -1.1        -0.9
  ## [131,]         -0.5        -1.6         -0.8        -0.6
  ## [132,]          0.0        -0.6         -0.5        -0.5
  ## [133,]         -1.5        -1.6         -1.3        -0.3
  ## [134,]         -1.6        -1.6         -1.8        -1.0
  ## [135,]         -1.8        -1.8         -1.3        -1.1
  ## [136,]         -0.2        -1.4         -0.8        -0.2
  ## [137,]         -1.6        -1.0         -1.3        -0.1
  ## [138,]         -1.5        -1.3         -1.4        -0.7
  ## [139,]         -1.9        -1.4         -2.1        -0.7
  ## [140,]         -1.0        -1.3         -1.5        -0.4
  ## [141,]         -1.2        -1.3         -1.3        -0.1
  ## [142,]         -1.0        -1.3         -1.8        -0.2
  ## [143,]         -2.1        -1.7         -1.8        -0.6
  ## [144,]         -1.1        -1.2         -1.0        -0.2
  ## [145,]         -1.2        -1.1         -1.2         0.0
  ## [146,]         -1.2        -1.4         -1.7        -0.2
  ## [147,]         -1.6        -1.9         -1.9        -0.6
  ## [148,]         -1.4        -1.4         -1.7        -0.5
  ## [149,]         -1.7        -1.0         -1.5        -0.2
  ## [150,]         -2.0        -1.4         -1.8        -0.7
  6 Atributos de una matriz y de un array
  Un objeto matrixtiene los siguientes atributos
  
  Atributo	Descripcin
  length	nmero de datos
  mode	tipo de datos
  dim	tamao de cada dimensin
  dimnames	nombres de filas y columnas
  class	clase "matrix"
  ------	----------